/****************************************************************************
** Form implementation generated from reading ui file 'chat.ui'
**
** Created: Wed Apr 18 11:19:41 2001
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "chatclientview.h"

#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qmultilineedit.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <klocale.h>
#include <qsocket.h>
#include <qspinbox.h>
#include <qpushbutton.h>
#include <qcombobox.h>

/* 
 *  Constructs a ChatClient which is a child of 'parent', with the
 *  name 'name' and widget flags set to 'f' 
 */
ChatClientView::ChatClientView(QString host, QStringList server, int port, QWidget* parent,
                               const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    resize( 600, 515 );

    QLabel* eSay = new QLabel( this, "eSay" );
    eSay->setText( i18n( "Say:" ) );

    QLabel* eChat = new QLabel( this, "eChat" );
    eChat->setText( i18n( "Chat:" ) );

    QLabel* eLogins = new QLabel( this, "eLogins" );
    eLogins->setText( i18n( "Logged on:" ) );

    QLabel* eServer = new QLabel(this, "eServer");
    eServer->setText(i18n ("Connect to") );

    QLabel* ePort = new QLabel(this, "ePort");
    ePort->setText(i18n ("on Port") );

    Say = new QLineEdit( this, "Say" );

    Logins = new QListBox( this, "Logins" );

    Chat = new QMultiLineEdit( this, "Chat" );
    Chat->setReadOnly( true );

    Port = new QSpinBox(1024, 65535, 1, this, "Port");
    Port->setValue(port);

    Server = new QComboBox(this, "Server");
    Server->setEditable(true);
    Server->insertStringList(server);
    for (int i = 0; i < Server->count();i++)
      if(host == Server->text(i))
        Server->setCurrentItem(i);

    Connect = new QPushButton(i18n("Connect"), this, "Connect");
//    Connect->setFixedHeight(30);

    Disconnect = new QPushButton(i18n("Disconnect"), this, "Disconnect");
//    Disconnect->setFixedHeight(30);

    disconnected();

    QBoxLayout* buttonLayout = new QBoxLayout(QBoxLayout::LeftToRight);

    buttonLayout->setSpacing(10);
    buttonLayout->addWidget(eServer, 0);
    buttonLayout->addWidget(Server, 2);
    buttonLayout->addWidget(ePort, 0);
    buttonLayout->addWidget(Port, 0);
    buttonLayout->addWidget(Connect, 1);
    buttonLayout->addWidget(Disconnect, 1);

    QBoxLayout* sayLayout = new QBoxLayout(QBoxLayout::LeftToRight);

    sayLayout->setSpacing(10);
    sayLayout->addWidget(eSay);
    sayLayout->addWidget(Say);

    QBoxLayout* chatLayout = new QBoxLayout(QBoxLayout::TopToBottom);

    chatLayout->setSpacing(10);
    chatLayout->addWidget(eChat);
    chatLayout->addWidget(Chat);
    chatLayout->addLayout(sayLayout);

    QBoxLayout* loginLayout = new QBoxLayout(QBoxLayout::TopToBottom);

    loginLayout->setSpacing(10);
    loginLayout->addWidget(eLogins);
    loginLayout->addWidget(Logins);

    QBoxLayout* loginAndChatLayout = new QBoxLayout(QBoxLayout::LeftToRight);

    loginAndChatLayout->addLayout(chatLayout, 44);
    loginAndChatLayout->addLayout(loginLayout, 13);

    QBoxLayout* allLayout = new QBoxLayout(this, QBoxLayout::TopToBottom, 10);

    allLayout->addLayout(loginAndChatLayout);
    allLayout->addLayout(buttonLayout);

    connect(Connect, SIGNAL (clicked()),
            this, SLOT (connectServer()));

    connect(Disconnect, SIGNAL (clicked()),
            this, SLOT (disconnectServer()));

    connect(Say, SIGNAL (returnPressed()),
            this, SLOT (SayReturnPressed()));
}

/*  
 *  Destroys the object and frees any allocated resources
 */
ChatClientView::~ChatClientView()
{
    // no need to delete child widgets, Qt does it all for us
}

void ChatClientView::connected(){
 Say->setEnabled(true);
 Port->setEnabled(false);
 Connect->setEnabled(false);
 Disconnect->setEnabled(true);
 Server->setEnabled(false);
 Logins->setEnabled(true);
}

/** No descriptions */
void ChatClientView::disconnected(){
 Say->setEnabled(false);
 Disconnect->setEnabled(false);
 Connect->setEnabled(true);
 Port->setEnabled(true);
 Server->setEnabled(true);
 Logins->setEnabled(false);
 Logins->clear();
}
/** emits the connectTo Signal with the right parameters */
void ChatClientView::connectServer(){
 Port->setEnabled(false);
 Server->setEnabled(false);
 Connect->setEnabled(false);
 Disconnect->setEnabled(true);
 emit connectTo(Server->currentText(), Port->value());
}
/** disconnects the Server */
void ChatClientView::disconnectServer(){
 Disconnect->setEnabled(false);
 emit disconnect();
}
/** No descriptions */
void ChatClientView::displayNewMessage(QString msg){
 Chat->append(msg);
 Chat->setCursorPosition(Chat->numLines(), 1);
}
/** No descriptions */
void ChatClientView::SayReturnPressed(){
 emit newMessage(Say->text());
 Say->clear();
}
/** No descriptions */
void ChatClientView::newChater(QString name){
 Logins->insertItem(name);
}
/** No descriptions */
void ChatClientView::removeChater(QString name){
 Logins->removeItem(Logins->index(Logins->findItem(name)));
}
/** gets the text of the higlighed chater */
QString ChatClientView::getCurrentText(){
 return Logins->currentText();
}
/** No descriptions */
QString ChatClientView::ChatText(){
 return Chat->text();
}
/** No descriptions */
void ChatClientView::cleanChat(){
 Chat->clear();
}
