/****************************************************************************
** Form implementation generated from reading ui file 'shortcutdialog.ui'
**
** Created: Tue Nov 20 17:43:23 2001
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "shortcutdialog.h"

#include <qframe.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <klocale.h>


/* 
 *  Constructs a ShortcutDialog which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ShortcutDialog::ShortcutDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "ShortcutDialog" );
    resize( 428, 301 );
    setCaption( i18n( "Define your own shortcuts" ) );
    ShortcutDialogLayout = new QVBoxLayout( this );
    ShortcutDialogLayout->setSpacing( 10 );
    ShortcutDialogLayout->setMargin( 10 );

    shortcuts = new QListView( this, "shortcuts" );
    shortcuts->addColumn( i18n( "Defined Shortcuts" ) );
    QListViewItem * item = new QListViewItem( shortcuts, 0 );
    item->setText( 0, i18n( "Shut up" ) );

    ShortcutDialogLayout->addWidget( shortcuts );

    QHBoxLayout* shortcutLayout = new QHBoxLayout();
    shortcutLayout->setSpacing(10);

    shortcut = new QLineEdit( this, "shortcut" );
    shortcut->setText( i18n( "Shut up" ) );
    shortcutLayout->addWidget( shortcut );

    change = new QPushButton(this);
    change->setText("&Change");
    shortcutLayout->addWidget(change);

    add = new QPushButton(this);
    add->setText(i18n("A&dd"));
    shortcutLayout->addWidget(add);

    remove = new QPushButton(this);
    remove->setText(i18n("&Remove"));
    shortcutLayout->addWidget(remove);

    ShortcutDialogLayout->addLayout(shortcutLayout);

    Line = new QFrame( this, "Line" );
    Line->setFrameStyle( QFrame::HLine | QFrame::Sunken );
    ShortcutDialogLayout->addWidget( Line );

    buttonsLayout = new QHBoxLayout;
    buttonsLayout->setSpacing( 10 );
    buttonsLayout->setMargin( 0 );

    keyBindings = new QPushButton( this, "keyBindings" );
    keyBindings->setText( i18n( "&Launch Key Bindings" ) );
    buttonsLayout->addWidget( keyBindings );

    cancel = new QPushButton( this, "cancel" );
    cancel->setText( i18n( "&Cancel" ) );
    buttonsLayout->addWidget( cancel );
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    buttonsLayout->addItem( spacer );
    ShortcutDialogLayout->addLayout( buttonsLayout );

    // signals and slots connections
    connect( cancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( keyBindings, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( change, SIGNAL ( clicked() ) , this, SLOT( slotChange() ) );
    connect( add, SIGNAL ( clicked() ) , this, SLOT( slotAdd() ) );
    connect( remove, SIGNAL ( clicked() ) , this, SLOT( slotRemove() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
ShortcutDialog::~ShortcutDialog()
{
    // no need to delete child widgets, Qt does it all for us
}
/** called when chage is pressed */
void ShortcutDialog::slotChange(){
 if(shortcuts->currentItem() != 0 )
   shortcuts->currentItem()->setText(0, shortcut->text());
}
/** called when add was pressed */
void ShortcutDialog::slotAdd(){
 QListViewItem * item = new QListViewItem( shortcuts, 0 );
 item->setText(0, shortcut->text());
 shortcuts->setCurrentItem(item);
}
/** called when remove was pressed */
void ShortcutDialog::slotRemove(){
 if(shortcuts->currentItem() != 0 )
   shortcuts->removeItem(shortcuts->currentItem());
}
/** returns the defined shortcuts */
QStringList ShortcutDialog::definedShortcuts(){
 QStringList list;
 for ( QListViewItemIterator it( shortcuts ); it.current(); ++it )
   list += it.current()->text(0);
 return list;
}
